#!/bin/sh

if [ "$APKG_PKG_STATUS" == "install" ] || [ "$APKG_PKG_STATUS" == "upgrade" ]; then

    # gather the configuration information from apache
    APACHE_ROOT=$(apache2 -V | grep 'HTTPD_ROOT' | sed 's/^[^"]*"\([^"]*\)".*/\1/')
    CONF_FILE=$(apache2 -V | grep 'SERVER_CONFIG_FILE' | sed 's/^[^"]*"\([^"]*\)".*/\1/')
    DOCUMENT_ROOT=$(grep '^DocumentRoot' "${APACHE_ROOT}/${CONF_FILE}" | sed 's/^[^"]*"\([^"]*\)".*/\1/')
    
    # create a crontab to allow updating of feeds at most every 30 minutes (actual frequency of update is set in the app settings)
    (crontab -u admin -l ; echo "*/30  *  *  *  * /usr/builtin/bin/php ${APKG_PKG_DIR}/files/app/actualize_script.php > /tmp/FreshRSS.log 2>&1") | crontab -u admin -
    
    # expose only the p folder
    ln -s  ${APKG_PKG_DIR}/files/p ${DOCUMENT_ROOT}/freshrss
    
fi

if [ "$APKG_PKG_STATUS" == "upgrade" ] ; then

    # restore config data
    cp -af ${APKG_TEMP_DIR}/users/* ${APKG_PKG_DIR}/files/data/users/.
    cp -af ${APKG_TEMP_DIR}/config.php ${APKG_PKG_DIR}/files/data/.
    
    # remove install check
    rm ${APKG_PKG_DIR}/files/data/do-install.txt
           
fi
